/*
frshuf.h Version 0.1.0 - Fischer Random Shuffle Header
Copyright (C) 2004  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

/* B   B   K   R   R   Q   N   N       */
/* 4 x 4 x 2 x 2 x 3 x 3 x 1 x 1 = 576 */
/* 4 x 4 x 2 x 4 x 1 x 3 x 1 x 1 = 384 */
/* Total Permutations            = 960 */

#define COMBOS 960
#define WDTH 16
#define LEN (COMBOS * WDTH)
#define RND_BYTE 15
#define SHFLERR 300000000
#define SYSERR  400000000
#define IDM_FEN     1
#define IDM_LIST    2
#define IDM_CHMAST  3
#define IDM_EXIT    4
#define IDM_COPYING 5
#define IDM_ABOUT   6

typedef struct FRFMT {
   char game[COMBOS][WDTH];
   } FRFMT;

typedef struct shflfmt {
   int indx;
   char game[LEN + 16];
   } shflfmt;

shflfmt *shflinit(void);
void shflcomb(shflfmt *shuf);
FRFMT *shuffle(void);
unsigned char *rndinit(void);
int rnd(unsigned char *rndSeed);
unsigned int rndpwr(int bits,unsigned char *rndSeed);
unsigned int rndnum(unsigned int lmt,unsigned char *rndSeed);
